'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _os = require('os');

var _os2 = _interopRequireDefault(_os);

var _opn = require('opn');

var _opn2 = _interopRequireDefault(_opn);

var _spotify = require('./spotify');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SpotifyManager = function () {
  function SpotifyManager() {
    (0, _classCallCheck3.default)(this, SpotifyManager);

    switch (_os2.default.platform()) {
      case 'darwin':
        this.spotifyService = new _spotify.SpotifyDarwin();
        break;

      case 'linux':
        this.spotifyService = new _spotify.SpotifyLinux();
        break;

      default:
        this.spotifyService = new _spotify.SpotifyDefault();
    }
  }

  (0, _createClass3.default)(SpotifyManager, [{
    key: 'launchSpotify',
    value: function launchSpotify() {
      return (0, _opn2.default)('spotify://');
    }
  }, {
    key: 'supportedActions',
    value: function supportedActions() {
      return this.spotifyService.supportedActions();
    }
  }, {
    key: 'isRunning',
    value: function isRunning() {
      return this.spotifyService.isRunning();
    }
  }, {
    key: 'getState',
    value: function getState() {
      return this.spotifyService.getState();
    }
  }, {
    key: 'togglePlayPause',
    value: function togglePlayPause() {
      return this.spotifyService.togglePlayPause();
    }
  }, {
    key: 'previousTrack',
    value: function previousTrack() {
      return this.spotifyService.previousTrack();
    }
  }, {
    key: 'nextTrack',
    value: function nextTrack() {
      return this.spotifyService.nextTrack();
    }
  }, {
    key: 'getTrack',
    value: function getTrack() {
      return this.spotifyService.getTrack();
    }
  }]);
  return SpotifyManager;
}();

exports.default = SpotifyManager;