'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray2 = require('babel-runtime/helpers/slicedToArray');

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _promise = require('babel-runtime/core-js/promise');

var _promise2 = _interopRequireDefault(_promise);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _dbusNative = require('dbus-native');

var _dbusNative2 = _interopRequireDefault(_dbusNative);

var _lodash = require('lodash');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var SpotifyLinux = function () {
  function SpotifyLinux() {
    (0, _classCallCheck3.default)(this, SpotifyLinux);

    this.sessionBus = _dbusNative2.default.sessionBus();
    this.spotifyService = this.sessionBus.getService('org.mpris.MediaPlayer2.spotify');
  }

  (0, _createClass3.default)(SpotifyLinux, [{
    key: 'supportedActions',
    value: function supportedActions() {
      return ['togglePlayPause', 'previousTrack', 'nextTrack'];
    }
  }, {
    key: 'isRunning',
    value: function isRunning() {
      return this._getSpotifyInterface().then(function () {
        return _promise2.default.resolve(true);
      }).catch(function () {
        return _promise2.default.resolve(false);
      });
    }
  }, {
    key: 'getState',
    value: function getState() {
      var _this = this;

      return this._getSpotifyInterface().then(function (spotify) {
        return _this._getPlaybackStatus(spotify);
      }).then(function (status) {
        return _promise2.default.resolve({ state: (0, _lodash.toLower)(status) });
      });
    }
  }, {
    key: 'getTrack',
    value: function getTrack() {
      var _this2 = this;

      return this._getSpotifyInterface().then(function (spotify) {
        return _this2._getMetadata(spotify);
      });
    }
  }, {
    key: 'togglePlayPause',
    value: function togglePlayPause() {
      var _this3 = this;

      return this._getSpotifyInterface().then(function (spotify) {
        return _this3._playPause(spotify);
      }).then(function (spotify) {
        return _this3._getPlaybackStatus(spotify);
      }).then(function (status) {
        return _promise2.default.resolve({ state: (0, _lodash.toLower)(status) });
      });
    }
  }, {
    key: 'previousTrack',
    value: function previousTrack() {
      var _this4 = this;

      return this._getSpotifyInterface().then(function (spotify) {
        return _this4._previous(spotify);
      }).then(function (spotify) {
        return _this4._getMetadata(spotify);
      });
    }
  }, {
    key: 'nextTrack',
    value: function nextTrack() {
      var _this5 = this;

      return this._getSpotifyInterface().then(function (spotify) {
        return _this5._next(spotify);
      }).then(function (spotify) {
        return _this5._getMetadata(spotify);
      });
    }

    // Internal methods

  }, {
    key: '_getSpotifyInterface',
    value: function _getSpotifyInterface() {
      var _this6 = this;

      return new _promise2.default(function (resolve, reject) {
        _this6.spotifyService.getInterface('/org/mpris/MediaPlayer2', 'org.mpris.MediaPlayer2.Player', function (err, spotify) {
          if (err) {
            reject(err);
          } else {
            resolve(spotify);
          }
        });
      });
    }
  }, {
    key: '_getPlaybackStatus',
    value: function _getPlaybackStatus(spotifyInterface) {
      return new _promise2.default(function (resolve, reject) {
        spotifyInterface.PlaybackStatus(function (err, status) {
          if (err) {
            reject(err);
          } else {
            resolve(status);
          }
        });
      });
    }
  }, {
    key: '_getMetadata',
    value: function _getMetadata(spotifyInterface) {
      return new _promise2.default(function (resolve, reject) {
        spotifyInterface.Metadata(function (err, metadata) {
          if (err) {
            reject(err);
          } else {
            var m = (0, _lodash.reduce)(metadata, function (dst, m) {
              var _m = (0, _slicedToArray3.default)(m, 2),
                  k = _m[0],
                  v = _m[1];

              var _v = (0, _slicedToArray3.default)(v, 2),
                  values = _v[1];

              var key = (0, _lodash.split)(k, ':')[1];
              var val = values[0];
              dst[key] = Array.isArray(val) ? (0, _lodash.join)(val, ' & ') : val;
              return dst;
            }, {});
            m.name = m.title;
            resolve(m);
          }
        });
      });
    }
  }, {
    key: '_playPause',
    value: function _playPause(spotifyInterface) {
      return new _promise2.default(function (resolve, reject) {
        try {
          spotifyInterface.PlayPause(function () {
            setTimeout(function () {
              return resolve(spotifyInterface);
            }, 500);
          });
        } catch (err) {
          reject(err);
        }
      });
    }
  }, {
    key: '_next',
    value: function _next(spotifyInterface) {
      return new _promise2.default(function (resolve, reject) {
        try {
          spotifyInterface.Next(function () {
            setTimeout(function () {
              return resolve(spotifyInterface);
            }, 500);
          });
        } catch (err) {
          reject(err);
        }
      });
    }
  }, {
    key: '_previous',
    value: function _previous(spotifyInterface) {
      return new _promise2.default(function (resolve, reject) {
        try {
          spotifyInterface.Previous(function () {
            setTimeout(function () {
              return resolve(spotifyInterface);
            }, 500);
          });
        } catch (err) {
          reject(err);
        }
      });
    }
  }]);
  return SpotifyLinux;
}();

exports.default = SpotifyLinux;