'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var defaultTheme = '\n  .hyper-spotify .hyper-spotify-overlay {\n    background-color: #FFF;\n  }\n  \n  .hyper-spotify .hyper-spotify-icon {\n    background-color: #FFF;\n  }\n\n  .hyper-spotify .hyper-spotify-icon-spotify {\n    background-color: #1ED760;\n  }\n\n  .hyper-spotify .hyper-spotify-track {\n    color: #FFF;\n  }\n';

var lightTheme = '\n  .hyper-spotify .hyper-spotify-overlay {\n    background-color: #FFF;\n  }\n\n  .hyper-spotify .hyper-spotify-icon {\n    background-color: #FFF;\n  }\n\n  .hyper-spotify .hyper-spotify-track {\n    color: #FFF;\n  }\n';

var darkTheme = '\n  .hyper-spotify .hyper-spotify-overlay {\n    background-color: #000;\n  }\n\n  .hyper-spotify .hyper-spotify-icon {\n    background-color: #000;\n  }\n\n  .hyper-spotify .hyper-spotify-track {\n    color: #000;\n  }\n';

// spotify:track:6wYJJ8AEhgS2euFsuTvZ1g
var halloweenTheme = '\n  .hyper-spotify .hyper-spotify-overlay {\n    background-color: #000;\n  }\n\n  .hyper-spotify .hyper-spotify-icon {\n    background-color: #D75C1B;\n  }\n\n  .hyper-spotify .hyper-spotify-track {\n    color: #D75C1B;\n  }\n';

var getThemeCssByVariables = exports.getThemeCssByVariables = function getThemeCssByVariables(overlayColor, iconColor, spotifyIconColor, textColor) {
  return '\n    .hyper-spotify .hyper-spotify-overlay {\n      background-color: ' + (overlayColor || '#FFF') + ';\n    }\n    \n    .hyper-spotify .hyper-spotify-icon {\n      background-color: ' + (iconColor || '#FFF') + ';\n    }\n\n    .hyper-spotify .hyper-spotify-icon-spotify {\n      background-color: ' + (spotifyIconColor || iconColor || '#1ED760') + ';\n    }\n\n    .hyper-spotify .hyper-spotify-track {\n      color: ' + (textColor || '#FFF') + ';\n    }\n  ';
};

var getThemeCssByName = exports.getThemeCssByName = function getThemeCssByName(themeName) {
  var _ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {},
      overlayColor = _ref.overlayColor,
      iconColor = _ref.iconColor,
      spotifyIconColor = _ref.spotifyIconColor,
      textColor = _ref.textColor;

  switch (themeName) {
    case 'light':
      return lightTheme;

    case 'dark':
      return darkTheme;

    case 'halloween':
      return halloweenTheme;

    case 'custom':
      return getThemeCssByVariables(overlayColor, iconColor, spotifyIconColor, textColor);

    default:
      return defaultTheme;
  }
};

exports.default = { getThemeCssByName: getThemeCssByName, getThemeCssByVariables: getThemeCssByVariables };